commit bf3a44ff4192d3babf5b61a2e8c2337d924221fd
Author: freddy77 <freddy77>
Date:   Thu Sep 3 09:25:55 2009 +0000

    fix NTLM2 check

diff --git a/ChangeLog b/ChangeLog
index 3c157b2..f4b3806 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Sep  3 11:25:04 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/challenge.c: fix NTLM2 check
+
 Wed Sep  2 11:26:14 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/unittests/numeric.c: fix dblib numeric test for Sybase
 
@@ -1833,4 +1836,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2867 2009/09/02 09:27:01 freddy77 Exp $
+$Id: ChangeLog,v 1.2868 2009/09/03 09:25:55 freddy77 Exp $
diff --git a/src/tds/challenge.c b/src/tds/challenge.c
index dd32186..7422046 100644
--- a/src/tds/challenge.c
+++ b/src/tds/challenge.c
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: challenge.c,v 1.39 2009/06/09 08:55:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: challenge.c,v 1.40 2009/09/03 09:25:55 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -272,7 +272,21 @@ tds_answer_challenge(TDSSOCKET * tds,
 
 	memset(answer, 0, sizeof(TDSANSWER));
 
-	if (!(*flags & 0x80000)) {
+	if ((*flags & 0x80000) != 0) {
+		/* NTLM2 */
+		MD5_CTX md5_ctx;
+
+		generate_random_buffer(hash, 8);
+		memset(hash + 8, 0, 16);
+		memcpy(answer->lm_resp, hash, 24);
+
+		MD5Init(&md5_ctx);
+		MD5Update(&md5_ctx, challenge, 8);
+		MD5Update(&md5_ctx, hash, 8);
+		MD5Final(&md5_ctx, ntlm2_challenge);
+		challenge = ntlm2_challenge;
+		memset(&md5_ctx, 0, sizeof(md5_ctx));
+	} else if (names_blob_len <= 0) {
 		/* NTLM */
 		size_t len, i;
 		unsigned char passwd_buf[MAX_PW_SZ];
@@ -297,7 +311,7 @@ tds_answer_challenge(TDSSOCKET * tds,
 
 		tds_encrypt_answer(hash, challenge, answer->lm_resp);
 		memset(passwd_buf, 0, sizeof(passwd_buf));
-	} else if (names_blob_len > 0) {
+	} else {
 		/* NTLMv2 */
 		unsigned char *lm_v2_response;
 		unsigned char ntlm_v2_hash[16];
@@ -322,21 +336,9 @@ tds_answer_challenge(TDSSOCKET * tds,
 		if (!*ntlm_v2_response)
 			return TDS_FAIL;
 
+		/* local not supported */
+		*flags &= 0x4000;
 		return TDS_SUCCEED;
-	} else {
-		/* NTLM2 */
-		MD5_CTX md5_ctx;
-
-		generate_random_buffer(hash, 8);
-		memset(hash + 8, 0, 16);
-		memcpy(answer->lm_resp, hash, 24);
-
-		MD5Init(&md5_ctx);
-		MD5Update(&md5_ctx, challenge, 8);
-		MD5Update(&md5_ctx, hash, 8);
-		MD5Final(&md5_ctx, ntlm2_challenge);
-		challenge = ntlm2_challenge;
-		memset(&md5_ctx, 0, sizeof(md5_ctx));
 	}
 	*flags = 0x8201;
 

